import { Base, CATEGORY, CATEGORY_CREATE, CATEGORY_GET, CATEGORY_EDIT } from './../etc/base';
export declare class Category extends Base {
    constructor();
    /**
     * Creates a category
     *
     * @returns
     *      - Promise<CATEGORY_CREATE>
     *      - Otherwise Promise<RESONSE> error object.
     */
    createValidator(category: CATEGORY): Promise<any>;
    create(category: CATEGORY): Promise<CATEGORY_CREATE>;
    /**
     * Edits a category.
     *
     * @todo category exists validation.
     */
    editValidator(category: CATEGORY): Promise<any>;
    edit(category: CATEGORY): Promise<CATEGORY_EDIT>;
    /**
     *
     */
    deleteValidator(id: string): Promise<any>;
    delete(id: string): Promise<any>;
    categories(): Promise<Array<CATEGORY>>;
    get(id: string): Promise<CATEGORY_GET>;
}
